| The Gaudi Framework v32r1 (f65d50dc)

Public Types | Public Member Functions | Private Types | Private Member Functions | Private Attributes | Friends | List of all members
Gaudi::Functional::details::vector_of_const_< Container >::iterator Class Reference

`#include <GaudiAlg/FunctionalDetails.h>`

## Public Types
using | iterator_category = typename it_t::iterator_category
using | value_type = typename it_t::iterator_category
using | reference = typename it_t::reference
using | pointer = typename it_t::pointer
using | difference_type = typename it_t::difference_type

## Public Member Functions
ret_t | operator * () const
iterator & | operator++ ()
iterator & | operator-- ()
bool | is_null () const
| operator bool () const

## Private Types
using | it_t = typename ContainerVector::const_iterator
using | ret_t = std::conditional_t< is_pointer, ptr_t, ref_t >

## Private Member Functions
| iterator (it_t iter)

## Private Attributes
it_t | m_i

## Friends
class | vector_of_const_
bool | operator!= (const iterator &lhs, const iterator &rhs)
bool | operator== (const iterator &lhs, const iterator &rhs)
auto | operator- (const iterator &lhs, const iterator &rhs)

## Detailed Description

### template<typename Container>
class Gaudi::Functional::details::vector_of_const_< Container >::iterator

Definition at line 227 of file FunctionalDetails.h.

## Member Typedef Documentation

## ◆ difference_type

template<typename Container>

using Gaudi::Functional::details::vector_of_const_< Container >::iterator::difference_type = typename it_t::difference_type

Definition at line 239 of file FunctionalDetails.h.

## ◆ it_t

template<typename Container>

using Gaudi::Functional::details::vector_of_const_< Container >::iterator::it_t = typename ContainerVector::const_iterator
| private

Definition at line 228 of file FunctionalDetails.h.

## ◆ iterator_category

template<typename Container>

using Gaudi::Functional::details::vector_of_const_< Container >::iterator::iterator_category = typename it_t::iterator_category

Definition at line 235 of file FunctionalDetails.h.

## ◆ pointer

template<typename Container>

using Gaudi::Functional::details::vector_of_const_< Container >::iterator::pointer = typename it_t::pointer

Definition at line 238 of file FunctionalDetails.h.

## ◆ reference

template<typename Container>

using Gaudi::Functional::details::vector_of_const_< Container >::iterator::reference = typename it_t::reference

Definition at line 237 of file FunctionalDetails.h.

## ◆ ret_t

template<typename Container>

using Gaudi::Functional::details::vector_of_const_< Container >::iterator::ret_t = std::conditional_t<is_pointer, ptr_t, ref_t>
| private

Definition at line 232 of file FunctionalDetails.h.

## ◆ value_type

template<typename Container>

using Gaudi::Functional::details::vector_of_const_< Container >::iterator::value_type = typename it_t::iterator_category

Definition at line 236 of file FunctionalDetails.h.

## Constructor & Destructor Documentation

## ◆ iterator()

template<typename Container>

Gaudi::Functional::details::vector_of_const_< Container >::iterator::iterator | ( | it_t | iter | ) |
| inline private

Definition at line 231 of file FunctionalDetails.h.

231 : m_i( iter ) {}
Gaudi::Functional::details::vector_of_const_::iterator::m_i
it_t m_i
Definition: FunctionalDetails.h:229

## Member Function Documentation

## ◆ is_null()

template<typename Container>

bool Gaudi::Functional::details::vector_of_const_< Container >::iterator::is_null | ( |  | ) | const
| inline

Definition at line 253 of file FunctionalDetails.h.

253 { return !*m_i; }
Gaudi::Functional::details::vector_of_const_::iterator::m_i
it_t m_i
Definition: FunctionalDetails.h:229

## ◆ operator *()

template<typename Container>

ret_t Gaudi::Functional::details::vector_of_const_< Container >::iterator::operator * | ( |  | ) | const
| inline

Definition at line 244 of file FunctionalDetails.h.

244 { return details2::deref_if( *m_i, std::bool_constant<!is_pointer>{} ); }
Gaudi::Functional::details::details2::deref_if
T * deref_if(T *const t, std::false_type)
Definition: FunctionalDetails.h:206
Gaudi::Functional::details::vector_of_const_::iterator::m_i
it_t m_i
Definition: FunctionalDetails.h:229

## ◆ operator bool()

template<typename Container>

Gaudi::Functional::details::vector_of_const_< Container >::iterator::operator bool | ( |  | ) | const
| inline explicit

Definition at line 254 of file FunctionalDetails.h.

254 { return !is_null(); }
Gaudi::Functional::details::vector_of_const_::iterator::is_null
bool is_null() const
Definition: FunctionalDetails.h:253

## ◆ operator++()

template<typename Container>

iterator& Gaudi::Functional::details::vector_of_const_< Container >::iterator::operator++ | ( |  | ) |
| inline

Definition at line 245 of file FunctionalDetails.h.

245 {
246 ++m_i;
247 return *this;
248 }
Gaudi::Functional::details::vector_of_const_::iterator::m_i
it_t m_i
Definition: FunctionalDetails.h:229

## ◆ operator--()

template<typename Container>

iterator& Gaudi::Functional::details::vector_of_const_< Container >::iterator::operator-- | ( |  | ) |
| inline

Definition at line 249 of file FunctionalDetails.h.

249 {
250 --m_i;
251 return *this;
252 }
Gaudi::Functional::details::vector_of_const_::iterator::m_i
it_t m_i
Definition: FunctionalDetails.h:229

## Friends And Related Function Documentation

## ◆ operator!=

template<typename Container>

bool operator!= | ( | const iterator & | lhs,
|  | const iterator & | rhs
| ) |  |
| friend

Definition at line 241 of file FunctionalDetails.h.

241 { return lhs.m_i != rhs.m_i; }

## ◆ operator-

template<typename Container>

auto operator- | ( | const iterator & | lhs,
|  | const iterator & | rhs
| ) |  |
| friend

Definition at line 243 of file FunctionalDetails.h.

243 { return lhs.m_i - rhs.m_i; }

## ◆ operator==

template<typename Container>

bool operator== | ( | const iterator & | lhs,
|  | const iterator & | rhs
| ) |  |
| friend

Definition at line 242 of file FunctionalDetails.h.

242 { return lhs.m_i == rhs.m_i; }

## ◆ vector_of_const_

template<typename Container>

friend class vector_of_const_
| friend

Definition at line 230 of file FunctionalDetails.h.

## Member Data Documentation

## ◆ m_i

template<typename Container>

it_t Gaudi::Functional::details::vector_of_const_< Container >::iterator::m_i
| private

Definition at line 229 of file FunctionalDetails.h.

The documentation for this class was generated from the following file:

- GaudiAlg/GaudiAlg/FunctionalDetails.h